searchData={"items":[{"type":"module","title":"XRPL","doc":"XRPL is a library for interacting with the XRP Ledger.","ref":"XRPL.html"},{"type":"function","title":"XRPL.account_address_regex/0","doc":"Accounts in the XRP Ledger are identified by an address in the XRP Ledger's [base58][] format. The address is derived from the account's master public key, which is in turn derived from a secret key. An address is represented as a string in JSON and has the following characteristics:\n\nBetween 25 and 35 characters in length\nStarts with the character r\nUses alphanumeric characters, excluding the number \"0\" capital letter \"O\", capital letter \"I\", and lowercase letter \"l\"\nCase-sensitive\n\nOfficial documentation: https://xrpl.org/docs/references/protocol/data-types/basic-data-types/#addresses","ref":"XRPL.html#account_address_regex/0"},{"type":"function","title":"XRPL.currency_regex/0","doc":"The HTTP / WebSocket APIs support two formats of currency code:\n\nStandard Currency Codes: As a 3-character string such as \"EUR\" or \"USD\".\nNonstandard Currency Codes: As a 160-bit hexadecimal string, such as \"0158415500000000C1F76FF6ECB0BAC600000000\". This is uncommon.\nTokens with the same code can ripple across connected trust lines. Currency codes have no other behavior built into the XRP Ledger.\n\nOfficial documentation: https://xrpl.org/docs/references/protocol/data-types/currency-formats/#currency-codes","ref":"XRPL.html#currency_regex/0"},{"type":"function","title":"XRPL.delete/3","doc":"Perform a DELETE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    delete(\"/users\")\n    delete(\"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\")\n    delete(client, \"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\", body: %{name: \"Jon\"})","ref":"XRPL.html#delete/3"},{"type":"function","title":"XRPL.delete!/3","doc":"Perform a DELETE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    delete!(\"/users\")\n    delete!(\"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\")\n    delete!(client, \"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\", body: %{name: \"Jon\"})","ref":"XRPL.html#delete!/3"},{"type":"function","title":"XRPL.get/3","doc":"Perform a GET request.\n\nSee `request/1` or `request/2` for options definition.\n\n    get(\"/users\")\n    get(\"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\")\n    get(client, \"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\", body: %{name: \"Jon\"})","ref":"XRPL.html#get/3"},{"type":"function","title":"XRPL.get!/3","doc":"Perform a GET request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    get!(\"/users\")\n    get!(\"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\")\n    get!(client, \"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\", body: %{name: \"Jon\"})","ref":"XRPL.html#get!/3"},{"type":"function","title":"XRPL.head/3","doc":"Perform a HEAD request.\n\nSee `request/1` or `request/2` for options definition.\n\n    head(\"/users\")\n    head(\"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\")\n    head(client, \"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\", body: %{name: \"Jon\"})","ref":"XRPL.html#head/3"},{"type":"function","title":"XRPL.head!/3","doc":"Perform a HEAD request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    head!(\"/users\")\n    head!(\"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\")\n    head!(client, \"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\", body: %{name: \"Jon\"})","ref":"XRPL.html#head!/3"},{"type":"function","title":"XRPL.ledger_entry_regex/0","doc":"Each ledger entry has a unique ID. The ID is derived by hashing important contents of the entry, along with a namespace identifier. The ledger entry type determines the namespace identifier to use and which contents to include in the hash. This ensures every ID is unique. The hash function is SHA-512Half.\n\nGenerally, a ledger entry's ID is returned as the index field in JSON, at the same level as the object's contents. In transaction metadata, the ledger object's ID in JSON is LedgerIndex.\n\nOffer directories have special IDs, where part of the hash is replaced with the exchange rate of Offers in that directory.\n\n\nOfficial documentation: https://xrpl.org/docs/references/protocol/ledger-data/common-fields/","ref":"XRPL.html#ledger_entry_regex/0"},{"type":"function","title":"XRPL.ledger_hash_regex/0","doc":"","ref":"XRPL.html#ledger_hash_regex/0"},{"type":"function","title":"XRPL.ledger_index_regex/0","doc":"A ledger index is a 32-bit unsigned integer used to identify a ledger. The ledger index is sometimes known as the ledger's sequence number. (This is different from an account sequence.) The very first ledger was ledger index 1, and each new ledger has a ledger index that is 1 higher than the ledger index of the ledger immediately before it.\n\nThe ledger index indicates the order of the ledgers; the [Hash][] value identifies the exact contents of the ledger. Two ledgers with the same hash are always the same. For validated ledgers, hash values and ledger indexes are equally valid and correlate 1:1. However, this is not true for in-progress ledgers:\n\nTwo different rippled servers may have different contents for a current ledger with the same ledger index, due to latency in propagating transactions throughout the network.\nThere may be multiple closed ledger versions competing to be validated by consensus. These ledger versions have the same ledger index but different contents (and different hashes). Only one of these closed ledgers can become validated.\nThe current open ledger's hash is not calculated. This is because a current ledger's contents change over time, which would cause its hash to change, even though its ledger index stays the same. The hash of a ledger is only calculated when the ledger is closed.\nSpecifying Ledgers\nMany API methods require you to specify an instance of the ledger, with the data retrieved being considered up-to-date as of that particular version of the shared ledger. The commands that accept a ledger version all work the same way. There are three ways you can specify which ledger you want to use:\n\nSpecify a ledger by its Ledger Index in the ledger_index parameter. Each closed ledger has a ledger index that is 1 higher than the previous ledger. (The very first ledger had ledger index 1.)\n\n\n\n\"ledger_index\": 61546724\nSpecify a ledger by its Hash value in the ledger_hash parameter.\n\n\n\n\"ledger_hash\": \"8BB204CE37CFA7A021A16B5F6143400831C4D1779E6FE538D9AC561ABBF4A929\"\nSpecify a ledger by one of the following shortcuts, in the ledger_index parameter:\n\nvalidated for the most recent ledger that has been validated by consensus\n\n\n\n\"ledger_index\": \"validated\"\nclosed for the most recent ledger that has been closed for modifications and proposed for validation\n\ncurrent for the server's current working version of the ledger.\n\nThere is also a deprecated ledger parameter which accepts any of the above three formats. Do not use this parameter; it may be removed without further notice.\n\nIf you do not specify a ledger, the server decides which ledger to use to serve the request. By default, the server chooses the current (in-progress) ledger. In Reporting Mode, the server uses the most recent validated ledger instead. Do not provide more than one field specifying ledgers.\n\nNote: Do not rely on the default behavior for specifying a ledger; it is subject to change. Always specify a ledger version in the request if you can.\n\nReporting Mode does not record ledger data until it has been validated. If you make a request to a Reporting Mode server for the current or closed ledger, the server forwards the request to a P2P Mode server. If you request a ledger index or hash that is not validated, a Reporting Mode server responds with a lgrNotFound error.\nOfficial documentation: https://xrpl.org/docs/references/protocol/data-types/basic-data-types/#ledger-index","ref":"XRPL.html#ledger_index_regex/0"},{"type":"function","title":"XRPL.options/3","doc":"Perform a OPTIONS request.\n\nSee `request/1` or `request/2` for options definition.\n\n    options(\"/users\")\n    options(\"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\")\n    options(client, \"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\", body: %{name: \"Jon\"})","ref":"XRPL.html#options/3"},{"type":"function","title":"XRPL.options!/3","doc":"Perform a OPTIONS request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    options!(\"/users\")\n    options!(\"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\")\n    options!(client, \"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\", body: %{name: \"Jon\"})","ref":"XRPL.html#options!/3"},{"type":"function","title":"XRPL.patch/4","doc":"Perform a PATCH request.\n\nSee `request/1` or `request/2` for options definition.\n\n    patch(\"/users\", %{name: \"Jon\"})\n    patch(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch(client, \"/users\", %{name: \"Jon\"})\n    patch(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"XRPL.html#patch/4"},{"type":"function","title":"XRPL.patch!/4","doc":"Perform a PATCH request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    patch!(\"/users\", %{name: \"Jon\"})\n    patch!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch!(client, \"/users\", %{name: \"Jon\"})\n    patch!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"XRPL.html#patch!/4"},{"type":"function","title":"XRPL.post/4","doc":"Perform a POST request.\n\nSee `request/1` or `request/2` for options definition.\n\n    post(\"/users\", %{name: \"Jon\"})\n    post(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post(client, \"/users\", %{name: \"Jon\"})\n    post(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"XRPL.html#post/4"},{"type":"function","title":"XRPL.post!/4","doc":"Perform a POST request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    post!(\"/users\", %{name: \"Jon\"})\n    post!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post!(client, \"/users\", %{name: \"Jon\"})\n    post!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"XRPL.html#post!/4"},{"type":"function","title":"XRPL.public_key_regex/0","doc":"","ref":"XRPL.html#public_key_regex/0"},{"type":"function","title":"XRPL.put/4","doc":"Perform a PUT request.\n\nSee `request/1` or `request/2` for options definition.\n\n    put(\"/users\", %{name: \"Jon\"})\n    put(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put(client, \"/users\", %{name: \"Jon\"})\n    put(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"XRPL.html#put/4"},{"type":"function","title":"XRPL.put!/4","doc":"Perform a PUT request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    put!(\"/users\", %{name: \"Jon\"})\n    put!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put!(client, \"/users\", %{name: \"Jon\"})\n    put!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"XRPL.html#put!/4"},{"type":"function","title":"XRPL.request/2","doc":"Perform a request.","ref":"XRPL.html#request/2"},{"type":"function","title":"Options - XRPL.request/2","doc":"- `:method` - the request method, one of [`:head`, `:get`, `:delete`, `:trace`, `:options`, `:post`, `:put`, `:patch`]\n- `:url` - either full url e.g. \"http://example.com/some/path\" or just \"/some/path\" if using `Tesla.Middleware.BaseUrl`\n- `:query` - a keyword list of query params, e.g. `[page: 1, per_page: 100]`\n- `:headers` - a keyworld list of headers, e.g. `[{\"content-type\", \"text/plain\"}]`\n- `:body` - depends on used middleware:\n    - by default it can be a binary\n    - if using e.g. JSON encoding middleware it can be a nested map\n    - if adapter supports it it can be a Stream with any of the above\n- `:opts` - custom, per-request middleware or adapter options","ref":"XRPL.html#request/2-options"},{"type":"function","title":"Examples - XRPL.request/2","doc":"ExampleApi.request(method: :get, url: \"/users/path\")\n\n    # use shortcut methods\n    ExampleApi.get(\"/users/1\")\n    ExampleApi.post(client, \"/users\", %{name: \"Jon\"})","ref":"XRPL.html#request/2-examples"},{"type":"function","title":"XRPL.request!/2","doc":"Perform request and raise in case of error.\n\nThis is similar to `request/2` behaviour from Tesla 0.x\n\nSee `request/2` for list of available options.","ref":"XRPL.html#request!/2"},{"type":"function","title":"XRPL.trace/3","doc":"Perform a TRACE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    trace(\"/users\")\n    trace(\"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\")\n    trace(client, \"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\", body: %{name: \"Jon\"})","ref":"XRPL.html#trace/3"},{"type":"function","title":"XRPL.trace!/3","doc":"Perform a TRACE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    trace!(\"/users\")\n    trace!(\"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\")\n    trace!(client, \"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\", body: %{name: \"Jon\"})","ref":"XRPL.html#trace!/3"},{"type":"macro","title":"XRPL.unwrap_or_raise/1","doc":"","ref":"XRPL.html#unwrap_or_raise/1"},{"type":"type","title":"XRPL.option/0","doc":"Options that may be passed to a request function. See `request/2` for detailed descriptions.","ref":"XRPL.html#t:option/0"},{"type":"module","title":"XRPL.Account","doc":"XRPL.Account is a module to interact with accounts on the XRP Ledger.\nAn account in the XRP Ledger represents a holder of XRP and a sender of transactions. Use these methods to work with account info.\n\nOfficial RPC documentation https://xrpl.org/account-methods.html","ref":"XRPL.Account.html"},{"type":"function","title":"XRPL.Account.account_channels/1","doc":"The account_channels method returns information about an account's Payment Channels.\nThis includes only channels where the specified account is the channel's source, not the destination. (A channel's \"source\" and \"owner\" are the same.)\nAll information retrieved is relative to a particular version of the ledger.\n\nOfficial documentation: https://xrpl.org/account_channels.html","ref":"XRPL.Account.html#account_channels/1"},{"type":"function","title":"XRPL.Account.account_channels!/1","doc":"","ref":"XRPL.Account.html#account_channels!/1"},{"type":"function","title":"XRPL.Account.account_currencies/1","doc":"The account_currencies command retrieves a list of currencies that an account can send or receive, based on its trust lines\n\nOfficial documentation: https://xrpl.org/account_currencies.html","ref":"XRPL.Account.html#account_currencies/1"},{"type":"function","title":"XRPL.Account.account_currencies!/1","doc":"","ref":"XRPL.Account.html#account_currencies!/1"},{"type":"function","title":"XRPL.Account.account_info/1","doc":"The account_info command retrieves information about an account, its activity, and its XRP balance.\nAll information retrieved is relative to a particular version of the ledger.\n\nOfficial documentation: https://xrpl.org/account_info.html","ref":"XRPL.Account.html#account_info/1"},{"type":"function","title":"XRPL.Account.account_info!/1","doc":"","ref":"XRPL.Account.html#account_info!/1"},{"type":"function","title":"XRPL.Account.account_lines/1","doc":"The account_lines command returns information about an account's trust lines, including balances in all non-XRP currencies and assets.\nAll information retrieved is relative to a particular version of the ledger.\n\nOfficial documentation: https://xrpl.org/account_lines.html","ref":"XRPL.Account.html#account_lines/1"},{"type":"function","title":"XRPL.Account.account_lines!/1","doc":"","ref":"XRPL.Account.html#account_lines!/1"},{"type":"function","title":"XRPL.Account.account_nfts/1","doc":"The account_nfts method returns a list of NFToken objects for the specified account.\n\nOfficial documentation: https://xrpl.org/account_nfts.html","ref":"XRPL.Account.html#account_nfts/1"},{"type":"function","title":"XRPL.Account.account_nfts!/1","doc":"","ref":"XRPL.Account.html#account_nfts!/1"},{"type":"function","title":"XRPL.Account.account_objects/1","doc":"The account_objects command returns the raw ledger format for all objects owned by an account.\nFor a higher-level view of an account's trust lines and balances, see the account_lines method instead.\n\nRef: https://xrpl.org/account_objects.html","ref":"XRPL.Account.html#account_objects/1"},{"type":"function","title":"XRPL.Account.account_objects!/1","doc":"","ref":"XRPL.Account.html#account_objects!/1"},{"type":"function","title":"XRPL.Account.account_offers/1","doc":"The account_offers method retrieves a list of offers made by a given account that are outstanding as of a particular ledger version.\n\nRef: https://xrpl.org/account_offers.html","ref":"XRPL.Account.html#account_offers/1"},{"type":"function","title":"XRPL.Account.account_offers!/1","doc":"","ref":"XRPL.Account.html#account_offers!/1"},{"type":"function","title":"XRPL.Account.account_tx/1","doc":"The account_tx method retrieves a list of transactions that involved the specified account.\n\nRef: https://xrpl.org/account_tx.html","ref":"XRPL.Account.html#account_tx/1"},{"type":"function","title":"XRPL.Account.account_tx!/1","doc":"","ref":"XRPL.Account.html#account_tx!/1"},{"type":"function","title":"XRPL.Account.changeset/3","doc":"Builds a changeset from the schema and params.","ref":"XRPL.Account.html#changeset/3"},{"type":"function","title":"XRPL.Account.gateway_balances/1","doc":"The gateway_balances command calculates the total balances issued by a given account, optionally excluding amounts held by operational addresses.\n\nRef: https://xrpl.org/gateway_balances.html","ref":"XRPL.Account.html#gateway_balances/1"},{"type":"function","title":"XRPL.Account.gateway_balances!/1","doc":"","ref":"XRPL.Account.html#gateway_balances!/1"},{"type":"function","title":"XRPL.Account.noripple_check/1","doc":"The noripple_check command provides a quick way to check the status of the Default Ripple field for an account and the No Ripple flag of its trust lines, compared with the recommended settings.\n\nRef: https://xrpl.org/noripple_check.html","ref":"XRPL.Account.html#noripple_check/1"},{"type":"function","title":"XRPL.Account.noripple_check!/1","doc":"","ref":"XRPL.Account.html#noripple_check!/1"},{"type":"function","title":"XRPL.Account.schema/1","doc":"","ref":"XRPL.Account.html#schema/1"},{"type":"function","title":"XRPL.Account.validate/1","doc":"Returns the validated parameters or an error changeset.","ref":"XRPL.Account.html#validate/1"},{"type":"function","title":"XRPL.Account.validate/3","doc":"Returns the validated parameters or an error changeset.\nExpects a schema to be defined with `defparams`.","ref":"XRPL.Account.html#validate/3"},{"type":"function","title":"XRPL.Account.xrpl/2","doc":"","ref":"XRPL.Account.html#xrpl/2"},{"type":"function","title":"XRPL.Account.xrpl/3","doc":"","ref":"XRPL.Account.html#xrpl/3"},{"type":"module","title":"XRPL.Clio","doc":"Use these methods to retrieve information using Clio server APIs.\n\nOfficial documentation: https://xrpl.org/docs/references/http-websocket-apis/public-api-methods/clio-server/","ref":"XRPL.Clio.html"},{"type":"function","title":"XRPL.Clio.changeset/3","doc":"Builds a changeset from the schema and params.","ref":"XRPL.Clio.html#changeset/3"},{"type":"function","title":"XRPL.Clio.ledger/1","doc":"The ledger command retrieves information about the public ledger.\n\nNote that the Clio server returns validated ledger data by default.\n\nOfficial documentation: https://xrpl.org/docs/references/http-websocket-apis/public-api-methods/clio-methods/ledger-clio/#ledger","ref":"XRPL.Clio.html#ledger/1"},{"type":"function","title":"XRPL.Clio.ledger!/1","doc":"","ref":"XRPL.Clio.html#ledger!/1"},{"type":"function","title":"XRPL.Clio.nft_history/1","doc":"The nft_history command asks the Clio server for past transaction metadata for the NFT being queried. New in: Clio v1.1.0\n\nNote nft_history returns only successful transactions associated with the NFT.\n\nOfficial documentation: https://xrpl.org/docs/references/http-websocket-apis/public-api-methods/clio-methods/nft_history/","ref":"XRPL.Clio.html#nft_history/1"},{"type":"function","title":"XRPL.Clio.nft_history!/1","doc":"","ref":"XRPL.Clio.html#nft_history!/1"},{"type":"function","title":"XRPL.Clio.nft_info/1","doc":"The nft_info command asks the Clio server for information about the NFT being queried.\n\nOfficial documentation: https://xrpl.org/docs/references/http-websocket-apis/public-api-methods/clio-methods/nft_info/","ref":"XRPL.Clio.html#nft_info/1"},{"type":"function","title":"XRPL.Clio.nft_info!/1","doc":"","ref":"XRPL.Clio.html#nft_info!/1"},{"type":"function","title":"XRPL.Clio.schema/1","doc":"","ref":"XRPL.Clio.html#schema/1"},{"type":"function","title":"XRPL.Clio.server_info/0","doc":"The server_info command asks the Clio server for a human-readable version of various information about the Clio server being queried. For rippled servers, see server_info (rippled) instead.\n\nOfficial documentation: https://xrpl.org/docs/references/http-websocket-apis/public-api-methods/clio-methods/server_info-clio/#server_info","ref":"XRPL.Clio.html#server_info/0"},{"type":"function","title":"XRPL.Clio.server_info!/0","doc":"","ref":"XRPL.Clio.html#server_info!/0"},{"type":"function","title":"XRPL.Clio.validate/1","doc":"Returns the validated parameters or an error changeset.","ref":"XRPL.Clio.html#validate/1"},{"type":"function","title":"XRPL.Clio.validate/3","doc":"Returns the validated parameters or an error changeset.\nExpects a schema to be defined with `defparams`.","ref":"XRPL.Clio.html#validate/3"},{"type":"function","title":"XRPL.Clio.xrpl/2","doc":"","ref":"XRPL.Clio.html#xrpl/2"},{"type":"function","title":"XRPL.Clio.xrpl/3","doc":"","ref":"XRPL.Clio.html#xrpl/3"},{"type":"module","title":"XRPL.Ledger","doc":"XRPL.Ledger is a module to interact with ledgers on the XRP Ledger.\nA ledger version contains a header, a transaction tree, and a state tree, which contain account settings, trustlines, balances, transactions, and other data.\nUse these methods to retrieve ledger info.\n\nOfficial RPC documentation: https://xrpl.org/ledger-methods.html","ref":"XRPL.Ledger.html"},{"type":"function","title":"XRPL.Ledger.changeset/3","doc":"Builds a changeset from the schema and params.","ref":"XRPL.Ledger.html#changeset/3"},{"type":"function","title":"XRPL.Ledger.ledger/1","doc":"Retrieve information about the public ledger.\n\nOfficial documentation: https://xrpl.org/ledger.html","ref":"XRPL.Ledger.html#ledger/1"},{"type":"function","title":"XRPL.Ledger.ledger!/1","doc":"","ref":"XRPL.Ledger.html#ledger!/1"},{"type":"function","title":"XRPL.Ledger.ledger_closed/0","doc":"The ledger_closed method returns the unique identifiers of the most recently closed ledger.\n(This ledger is not necessarily validated and immutable yet.)\n\nOfficial documentation: https://xrpl.org/ledger_closed.html","ref":"XRPL.Ledger.html#ledger_closed/0"},{"type":"function","title":"XRPL.Ledger.ledger_closed!/0","doc":"","ref":"XRPL.Ledger.html#ledger_closed!/0"},{"type":"function","title":"XRPL.Ledger.ledger_current/0","doc":"The ledger_current method returns the unique identifiers of the current in-progress ledger.\n\nThis command is mostly useful for testing, because the ledger returned is still in flux.\n\nOfficial documentation: https://xrpl.org/ledger_current.html","ref":"XRPL.Ledger.html#ledger_current/0"},{"type":"function","title":"XRPL.Ledger.ledger_current!/0","doc":"","ref":"XRPL.Ledger.html#ledger_current!/0"},{"type":"function","title":"XRPL.Ledger.ledger_data/1","doc":"The ledger_data method retrieves contents of the specified ledger.\nYou can iterate through several calls to retrieve the entire contents of a single ledger version.\n\nOfficial documentation: https://xrpl.org/ledger_data.html","ref":"XRPL.Ledger.html#ledger_data/1"},{"type":"function","title":"XRPL.Ledger.ledger_data!/1","doc":"","ref":"XRPL.Ledger.html#ledger_data!/1"},{"type":"function","title":"XRPL.Ledger.schema/1","doc":"","ref":"XRPL.Ledger.html#schema/1"},{"type":"function","title":"XRPL.Ledger.validate/1","doc":"Returns the validated parameters or an error changeset.","ref":"XRPL.Ledger.html#validate/1"},{"type":"function","title":"XRPL.Ledger.validate/3","doc":"Returns the validated parameters or an error changeset.\nExpects a schema to be defined with `defparams`.","ref":"XRPL.Ledger.html#validate/3"},{"type":"function","title":"XRPL.Ledger.xrpl/2","doc":"","ref":"XRPL.Ledger.html#xrpl/2"},{"type":"function","title":"XRPL.Ledger.xrpl/3","doc":"","ref":"XRPL.Ledger.html#xrpl/3"},{"type":"module","title":"XRPL.LedgerEntry","doc":"The ledger_entry method returns a single ledger entry from the XRP Ledger in its raw format.\nSee [ledger format](https://xrpl.org/ledger-object-types.html) for information on the different types of entries you can retrieve.\n\nOfficial documentation: https://xrpl.org/ledger_entry.html","ref":"XRPL.LedgerEntry.html"},{"type":"function","title":"XRPL.LedgerEntry.account_root/1","doc":"Retrieve an AccountRoot entry by its address. This is roughly equivalent to the account_info method.\n\nOfficial documentation: https://xrpl.org/ledger_entry.html#get-accountroot-object","ref":"XRPL.LedgerEntry.html#account_root/1"},{"type":"function","title":"XRPL.LedgerEntry.account_root!/1","doc":"","ref":"XRPL.LedgerEntry.html#account_root!/1"},{"type":"function","title":"XRPL.LedgerEntry.amm/1","doc":"Retrieve an Automated Market-Maker (AMM) object from the ledger. This is similar to amm_info method, but the ledger_entry version returns only the ledger entry as stored.\n\nOfficial documentation: https://xrpl.org/ledger_entry.html#get-amm-object","ref":"XRPL.LedgerEntry.html#amm/1"},{"type":"function","title":"XRPL.LedgerEntry.amm!/1","doc":"","ref":"XRPL.LedgerEntry.html#amm!/1"},{"type":"function","title":"XRPL.LedgerEntry.by_id/1","doc":"Retrieve any type of ledger object by its unique ID.\n\nOfficial documentation: https://xrpl.org/ledger_entry.html#get-ledger-object-by-id","ref":"XRPL.LedgerEntry.html#by_id/1"},{"type":"function","title":"XRPL.LedgerEntry.by_id!/1","doc":"","ref":"XRPL.LedgerEntry.html#by_id!/1"},{"type":"function","title":"XRPL.LedgerEntry.changeset/3","doc":"Builds a changeset from the schema and params.","ref":"XRPL.LedgerEntry.html#changeset/3"},{"type":"function","title":"XRPL.LedgerEntry.check/1","doc":"Retrieve a Check entry, which is a potential payment that can be cashed by its recipient.\n\nOfficial documentation: https://xrpl.org/ledger_entry.html#get-check-object","ref":"XRPL.LedgerEntry.html#check/1"},{"type":"function","title":"XRPL.LedgerEntry.check!/1","doc":"","ref":"XRPL.LedgerEntry.html#check!/1"},{"type":"function","title":"XRPL.LedgerEntry.deposit_preauth/1","doc":"Retrieve a DepositPreauth entry, which tracks preauthorization for payments to accounts requiring Deposit Authorization.\n\nOfficial documentation: https://xrpl.org/ledger_entry.html#get-depositpreauth-object","ref":"XRPL.LedgerEntry.html#deposit_preauth/1"},{"type":"function","title":"XRPL.LedgerEntry.deposit_preauth!/1","doc":"","ref":"XRPL.LedgerEntry.html#deposit_preauth!/1"},{"type":"function","title":"XRPL.LedgerEntry.directory_node/1","doc":"Retrieve a DirectoryNode, which contains a list of other ledger objects. Can be provided as string (object ID of the Directory) or as an object.\n\nOfficial documentation: https://xrpl.org/ledger_entry.html#get-directorynode-object","ref":"XRPL.LedgerEntry.html#directory_node/1"},{"type":"function","title":"XRPL.LedgerEntry.directory_node!/1","doc":"","ref":"XRPL.LedgerEntry.html#directory_node!/1"},{"type":"function","title":"XRPL.LedgerEntry.escrow/1","doc":"Retrieve an Escrow entry, which holds XRP until a specific time or condition is met. Can be provided as string (object ID of the Escrow) or as an object.\n\nOfficial documentation: https://xrpl.org/ledger_entry.html/#get-escrow-object","ref":"XRPL.LedgerEntry.html#escrow/1"},{"type":"function","title":"XRPL.LedgerEntry.escrow!/1","doc":"","ref":"XRPL.LedgerEntry.html#escrow!/1"},{"type":"function","title":"XRPL.LedgerEntry.nft_page/1","doc":"Return an NFT Page in its raw ledger format.\n\nOfficial documentation: https://xrpl.org/ledger_entry.html#get-nft-page","ref":"XRPL.LedgerEntry.html#nft_page/1"},{"type":"function","title":"XRPL.LedgerEntry.nft_page!/1","doc":"","ref":"XRPL.LedgerEntry.html#nft_page!/1"},{"type":"function","title":"XRPL.LedgerEntry.offer/1","doc":"Retrieve an Offer entry, which defines an offer to exchange currency. Can be provided as string (unique index of the Offer) or as an object.\n\nOfficial documentation: https://xrpl.org/ledger_entry.html#get-offer-object","ref":"XRPL.LedgerEntry.html#offer/1"},{"type":"function","title":"XRPL.LedgerEntry.offer!/1","doc":"","ref":"XRPL.LedgerEntry.html#offer!/1"},{"type":"function","title":"XRPL.LedgerEntry.payment_channel/1","doc":"Retrieve a PayChannel entry, which holds XRP for asynchronous payments.\n\nOfficial documentation: https://xrpl.org/ledger_entry.html#get-paychannel-object","ref":"XRPL.LedgerEntry.html#payment_channel/1"},{"type":"function","title":"XRPL.LedgerEntry.payment_channel!/1","doc":"","ref":"XRPL.LedgerEntry.html#payment_channel!/1"},{"type":"function","title":"XRPL.LedgerEntry.ripple_state/1","doc":"Retrieve a RippleState entry, which tracks a (non-XRP) currency balance between two accounts.\n\nOfficial documentation: https://xrpl.org/ledger_entry.html#get-ripplestate-object","ref":"XRPL.LedgerEntry.html#ripple_state/1"},{"type":"function","title":"XRPL.LedgerEntry.ripple_state!/1","doc":"","ref":"XRPL.LedgerEntry.html#ripple_state!/1"},{"type":"function","title":"XRPL.LedgerEntry.schema/1","doc":"","ref":"XRPL.LedgerEntry.html#schema/1"},{"type":"function","title":"XRPL.LedgerEntry.ticket/1","doc":"Retrieve a Ticket entry, which represents a sequence number set aside for future use. (Added by the TicketBatch amendment)\n\nOfficial documentation: https://xrpl.org/ledger_entry.html#get-ticket-object","ref":"XRPL.LedgerEntry.html#ticket/1"},{"type":"function","title":"XRPL.LedgerEntry.ticket!/1","doc":"","ref":"XRPL.LedgerEntry.html#ticket!/1"},{"type":"function","title":"XRPL.LedgerEntry.validate/1","doc":"Returns the validated parameters or an error changeset.","ref":"XRPL.LedgerEntry.html#validate/1"},{"type":"function","title":"XRPL.LedgerEntry.validate/3","doc":"Returns the validated parameters or an error changeset.\nExpects a schema to be defined with `defparams`.","ref":"XRPL.LedgerEntry.html#validate/3"},{"type":"function","title":"XRPL.LedgerEntry.xrpl/2","doc":"","ref":"XRPL.LedgerEntry.html#xrpl/2"},{"type":"function","title":"XRPL.LedgerEntry.xrpl/3","doc":"","ref":"XRPL.LedgerEntry.html#xrpl/3"},{"type":"module","title":"XRPL.Middleware.Error","doc":"Makes requests that don't respond to HTTP Success codes to return as a error\n\n\n#","ref":"XRPL.Middleware.Error.html"},{"type":"module","title":"Example usage - XRPL.Middleware.Error","doc":"```\ndefmodule MyClient do\n  use Tesla\n\n  plug(XRPL.Middleware.Error)\nend\n```","ref":"XRPL.Middleware.Error.html#module-example-usage"},{"type":"function","title":"XRPL.Middleware.Error.call/3","doc":"","ref":"XRPL.Middleware.Error.html#call/3"},{"type":"function","title":"XRPL.Middleware.Error.check_body/1","doc":"","ref":"XRPL.Middleware.Error.html#check_body/1"},{"type":"function","title":"XRPL.Middleware.Error.check_status/1","doc":"","ref":"XRPL.Middleware.Error.html#check_status/1"},{"type":"module","title":"XRPL.PathOrderbook","doc":"XRPL.PathOrderbook is a module to interact with orderbook modules on the XRP Ledger.\n\nPaths define a way for payments to flow through intermediary steps on their way from sender to receiver.\nPaths enable cross-currency payments by connecting sender and receiver through order books.\nUse these methods to work with paths and other books.\n\nOfficial RPC documentation https://xrpl.org/path-and-order-book-methods.html","ref":"XRPL.PathOrderbook.html"},{"type":"function","title":"XRPL.PathOrderbook.amm_info/1","doc":"The amm_info method retrieves information about an Automated Market Maker (AMM) account.\n\nOfficial documentation: https://xrpl.org/amm_info.html","ref":"XRPL.PathOrderbook.html#amm_info/1"},{"type":"function","title":"XRPL.PathOrderbook.amm_info!/1","doc":"","ref":"XRPL.PathOrderbook.html#amm_info!/1"},{"type":"function","title":"XRPL.PathOrderbook.book_offers/1","doc":"The book_offers method retrieves a list of Offers between two currencies, also known as an order book.\nThe response omits unfunded Offers and reports how much of each remaining Offer's total is currently funded.\n\nOfficial documentation: https://xrpl.org/book_offers.html","ref":"XRPL.PathOrderbook.html#book_offers/1"},{"type":"function","title":"XRPL.PathOrderbook.book_offers!/1","doc":"","ref":"XRPL.PathOrderbook.html#book_offers!/1"},{"type":"function","title":"XRPL.PathOrderbook.changeset/3","doc":"Builds a changeset from the schema and params.","ref":"XRPL.PathOrderbook.html#changeset/3"},{"type":"function","title":"XRPL.PathOrderbook.deposit_authorized/1","doc":"The deposit_authorized command indicates whether one account is authorized to send payments directly to another. See Deposit Authorization for information on how to require authorization to deliver money to your account.\n\nOfficial documentation: https://xrpl.org/deposit_authorized.html","ref":"XRPL.PathOrderbook.html#deposit_authorized/1"},{"type":"function","title":"XRPL.PathOrderbook.deposit_authorized!/1","doc":"","ref":"XRPL.PathOrderbook.html#deposit_authorized!/1"},{"type":"function","title":"XRPL.PathOrderbook.nft_buy_offers/1","doc":"The nft_buy_offers method returns a list of buy offers for a given NFToken object.\n\nOfficial documentation: https://xrpl.org/nft_buy_offers.html","ref":"XRPL.PathOrderbook.html#nft_buy_offers/1"},{"type":"function","title":"XRPL.PathOrderbook.nft_buy_offers!/1","doc":"","ref":"XRPL.PathOrderbook.html#nft_buy_offers!/1"},{"type":"function","title":"XRPL.PathOrderbook.nft_sell_offers/1","doc":"The nft_sell_offers method returns a list of sell offers for a given NFToken object.\n\nOfficial documentation: https://xrpl.org/nft_sell_offers.html","ref":"XRPL.PathOrderbook.html#nft_sell_offers/1"},{"type":"function","title":"XRPL.PathOrderbook.nft_sell_offers!/1","doc":"","ref":"XRPL.PathOrderbook.html#nft_sell_offers!/1"},{"type":"function","title":"XRPL.PathOrderbook.ripple_path_find/1","doc":"The ripple_path_find method is a simplified version of the path_find method that provides a single response with a payment path you can use right away. It is available in both the WebSocket and JSON-RPC APIs. However, the results tend to become outdated as time passes. Instead of making multiple calls to stay updated, you should instead use the path_find method to subscribe to continued updates where possible.\n\nAlthough the rippled server tries to find the cheapest path or combination of paths for making a payment, it is not guaranteed that the paths returned by this method are, in fact, the best paths.\n\nOfficial documentation: https://xrpl.org/ripple_path_find.html","ref":"XRPL.PathOrderbook.html#ripple_path_find/1"},{"type":"function","title":"XRPL.PathOrderbook.ripple_path_find!/1","doc":"","ref":"XRPL.PathOrderbook.html#ripple_path_find!/1"},{"type":"function","title":"XRPL.PathOrderbook.schema/1","doc":"","ref":"XRPL.PathOrderbook.html#schema/1"},{"type":"function","title":"XRPL.PathOrderbook.validate/1","doc":"Returns the validated parameters or an error changeset.","ref":"XRPL.PathOrderbook.html#validate/1"},{"type":"function","title":"XRPL.PathOrderbook.validate/3","doc":"Returns the validated parameters or an error changeset.\nExpects a schema to be defined with `defparams`.","ref":"XRPL.PathOrderbook.html#validate/3"},{"type":"function","title":"XRPL.PathOrderbook.xrpl/2","doc":"","ref":"XRPL.PathOrderbook.html#xrpl/2"},{"type":"function","title":"XRPL.PathOrderbook.xrpl/3","doc":"","ref":"XRPL.PathOrderbook.html#xrpl/3"},{"type":"module","title":"XRPL.Payment","doc":"XRPL.Payment is a module to interact with payment modules on the XRP Ledger.\n\nPayment channels are a tool for facilitating repeated, unidirectional payments, or temporary credit between two parties.\nUse these methods to work with payment channels.\n\nOfficial documentation: https://xrpl.org/payment-channel-methods.html","ref":"XRPL.Payment.html"},{"type":"function","title":"XRPL.Payment.changeset/3","doc":"Builds a changeset from the schema and params.","ref":"XRPL.Payment.html#changeset/3"},{"type":"function","title":"XRPL.Payment.channel_authorize/1","doc":"The channel_authorize method creates a signature that can be used to redeem a specific amount of XRP from a payment channel.\n\nOfficial documentation: https://xrpl.org/docs/references/http-websocket-apis/public-api-methods/payment-channel-methods/channel_authorize/","ref":"XRPL.Payment.html#channel_authorize/1"},{"type":"function","title":"XRPL.Payment.channel_authorize!/1","doc":"","ref":"XRPL.Payment.html#channel_authorize!/1"},{"type":"function","title":"XRPL.Payment.channel_verify/1","doc":"The channel_verify method verifies a signature that can be used to redeem a specific amount of XRP from a payment channel.\n\nOfficial documentation: https://xrpl.org/docs/references/http-websocket-apis/public-api-methods/payment-channel-methods/channel_verify/","ref":"XRPL.Payment.html#channel_verify/1"},{"type":"function","title":"XRPL.Payment.channel_verify!/1","doc":"","ref":"XRPL.Payment.html#channel_verify!/1"},{"type":"function","title":"XRPL.Payment.schema/1","doc":"","ref":"XRPL.Payment.html#schema/1"},{"type":"function","title":"XRPL.Payment.validate/1","doc":"Returns the validated parameters or an error changeset.","ref":"XRPL.Payment.html#validate/1"},{"type":"function","title":"XRPL.Payment.validate/3","doc":"Returns the validated parameters or an error changeset.\nExpects a schema to be defined with `defparams`.","ref":"XRPL.Payment.html#validate/3"},{"type":"function","title":"XRPL.Payment.xrpl/2","doc":"","ref":"XRPL.Payment.html#xrpl/2"},{"type":"function","title":"XRPL.Payment.xrpl/3","doc":"","ref":"XRPL.Payment.html#xrpl/3"},{"type":"module","title":"XRPL.ServerInfo","doc":"XRPL.ServerInfo is a module to interact with server_info modules on the XRP Ledger.\n\nUse these methods to retrieve information about the current state of the rippled server.\n\nOfficial documentation: https://xrpl.org/server-info-methods.html","ref":"XRPL.ServerInfo.html"},{"type":"function","title":"XRPL.ServerInfo.changeset/3","doc":"Builds a changeset from the schema and params.","ref":"XRPL.ServerInfo.html#changeset/3"},{"type":"function","title":"XRPL.ServerInfo.fee/0","doc":"The fee command reports the current state of the open-ledger requirements for the transaction cost. This requires the FeeEscalation amendment to be enabled.\n\nThis is a public command available to unprivileged users.\n\nOfficial documentation: https://xrpl.org/docs/references/http-websocket-apis/public-api-methods/server-info-methods/fee/","ref":"XRPL.ServerInfo.html#fee/0"},{"type":"function","title":"XRPL.ServerInfo.fee!/0","doc":"","ref":"XRPL.ServerInfo.html#fee!/0"},{"type":"function","title":"XRPL.ServerInfo.manifest/1","doc":"The manifest method reports the current \"manifest\" information for a given validator public key. The \"manifest\" is a block of data that authorizes an ephemeral signing key with a signature from the validator's master key pair.\n\nOfficial documentation: https://xrpl.org/docs/references/http-websocket-apis/public-api-methods/server-info-methods/manifest/","ref":"XRPL.ServerInfo.html#manifest/1"},{"type":"function","title":"XRPL.ServerInfo.manifest!/1","doc":"","ref":"XRPL.ServerInfo.html#manifest!/1"},{"type":"function","title":"XRPL.ServerInfo.schema/1","doc":"","ref":"XRPL.ServerInfo.html#schema/1"},{"type":"function","title":"XRPL.ServerInfo.server_definitions/0","doc":"The server_definitions command returns an SDK-compatible definitions.json, generated from the rippled instance currently running. You can use this to query a node in a network, quickly receiving the definitions necessary to serialize/deserialize its binary data.\n\nOfficial documentation: https://xrpl.org/docs/references/http-websocket-apis/public-api-methods/server-info-methods/server-definitions/","ref":"XRPL.ServerInfo.html#server_definitions/0"},{"type":"function","title":"XRPL.ServerInfo.server_definitions!/0","doc":"","ref":"XRPL.ServerInfo.html#server_definitions!/0"},{"type":"function","title":"XRPL.ServerInfo.server_info/0","doc":"The server_info command asks the server for a human-readable version of various information about the rippled server being queried. For Clio servers, see server_info (Clio) instead.\n\nOfficial documentation: https://xrpl.org/docs/references/http-websocket-apis/public-api-methods/server-info-methods/server-info/","ref":"XRPL.ServerInfo.html#server_info/0"},{"type":"function","title":"XRPL.ServerInfo.server_info!/0","doc":"","ref":"XRPL.ServerInfo.html#server_info!/0"},{"type":"function","title":"XRPL.ServerInfo.server_state/1","doc":"The server_state command asks the server for various machine-readable information about the rippled server's current state. The response is almost the same as the server_info method, but uses units that are easier to process instead of easier to read. (For example, XRP values are given in integer drops instead of scientific notation or decimal values, and time is given in milliseconds instead of seconds.)\n\nThe Clio server does not support server_state directly, but you can ask for the server_state of the rippled server that Clio is connected to. Specify \"ledger_index\": \"current\" (WebSocket) or \"params\": [{\"ledger_index\": \"current\"}] (JSON-RPC).\n\nOfficial documentation: https://xrpl.org/docs/references/http-websocket-apis/public-api-methods/server-info-methods/server_state/","ref":"XRPL.ServerInfo.html#server_state/1"},{"type":"function","title":"XRPL.ServerInfo.server_state!/1","doc":"","ref":"XRPL.ServerInfo.html#server_state!/1"},{"type":"function","title":"XRPL.ServerInfo.validate/1","doc":"Returns the validated parameters or an error changeset.","ref":"XRPL.ServerInfo.html#validate/1"},{"type":"function","title":"XRPL.ServerInfo.validate/3","doc":"Returns the validated parameters or an error changeset.\nExpects a schema to be defined with `defparams`.","ref":"XRPL.ServerInfo.html#validate/3"},{"type":"function","title":"XRPL.ServerInfo.xrpl/2","doc":"","ref":"XRPL.ServerInfo.html#xrpl/2"},{"type":"function","title":"XRPL.ServerInfo.xrpl/3","doc":"","ref":"XRPL.ServerInfo.html#xrpl/3"},{"type":"module","title":"XRPL.Transaction","doc":"XRPL.Transaction is a module to interact with transaction modules on the XRP Ledger.\nTransactions are the only thing that can modify the shared state of the XRP Ledger. All business on the XRP Ledger takes the form of transactions. Use these methods to work with transactions.\n\nOfficial RPC documentation https://xrpl.org/transaction-methods.html","ref":"XRPL.Transaction.html"},{"type":"function","title":"XRPL.Transaction.changeset/3","doc":"Builds a changeset from the schema and params.","ref":"XRPL.Transaction.html#changeset/3"},{"type":"function","title":"XRPL.Transaction.schema/1","doc":"","ref":"XRPL.Transaction.html#schema/1"},{"type":"function","title":"XRPL.Transaction.submit/1","doc":"A submit-only request includes the following parameters:\n\n  - `tx_blob` (String) - The signed transaction to submit, encoded as hex\n  - `fail_hard` (Boolean) - If true, the transaction fails if it cannot be applied immediately. Otherwise, the transaction is queued. (Optional; defaults to false)\n\nOfficial documentation: https://xrpl.org/docs/references/http-websocket-apis/public-api-methods/transaction-methods/submit/#submit","ref":"XRPL.Transaction.html#submit/1"},{"type":"function","title":"XRPL.Transaction.submit!/1","doc":"","ref":"XRPL.Transaction.html#submit!/1"},{"type":"function","title":"XRPL.Transaction.submit_multisigned/1","doc":"The submit_multisigned command applies a multi-signed transaction and sends it to the network to be included in future ledgers.\n(You can also submit multi-signed transactions in binary form using the submit command in submit-only mode.)\n\nOfficial documentation: https://xrpl.org/docs/references/http-websocket-apis/public-api-methods/transaction-methods/submit_multisigned/#submit_multisigned","ref":"XRPL.Transaction.html#submit_multisigned/1"},{"type":"function","title":"XRPL.Transaction.submit_multisigned!/1","doc":"","ref":"XRPL.Transaction.html#submit_multisigned!/1"},{"type":"function","title":"XRPL.Transaction.transaction_entry/1","doc":"The transaction_entry method retrieves information on a single transaction from a specific ledger version. (The tx method, by contrast, searches all ledgers for the specified transaction. We recommend using that method instead.)\n\nOfficial documentation: https://xrpl.org/docs/references/http-websocket-apis/public-api-methods/transaction-methods/transaction_entry/#transaction_entry","ref":"XRPL.Transaction.html#transaction_entry/1"},{"type":"function","title":"XRPL.Transaction.transaction_entry!/1","doc":"","ref":"XRPL.Transaction.html#transaction_entry!/1"},{"type":"function","title":"XRPL.Transaction.tx/1","doc":"The tx method retrieves information on a single transaction, by its identifying hash or its CTID.\n\nOfficial documentation: https://xrpl.org/docs/references/http-websocket-apis/public-api-methods/transaction-methods/tx/#tx","ref":"XRPL.Transaction.html#tx/1"},{"type":"function","title":"XRPL.Transaction.tx!/1","doc":"","ref":"XRPL.Transaction.html#tx!/1"},{"type":"function","title":"XRPL.Transaction.tx_history/1","doc":"The tx_history method retrieves some of the most recent transactions made.\n\nOfficial documentation: https://xrpl.org/docs/references/http-websocket-apis/public-api-methods/transaction-methods/tx_history","ref":"XRPL.Transaction.html#tx_history/1"},{"type":"function","title":"XRPL.Transaction.tx_history!/1","doc":"","ref":"XRPL.Transaction.html#tx_history!/1"},{"type":"function","title":"XRPL.Transaction.validate/1","doc":"Returns the validated parameters or an error changeset.","ref":"XRPL.Transaction.html#validate/1"},{"type":"function","title":"XRPL.Transaction.validate/3","doc":"Returns the validated parameters or an error changeset.\nExpects a schema to be defined with `defparams`.","ref":"XRPL.Transaction.html#validate/3"},{"type":"function","title":"XRPL.Transaction.xrpl/2","doc":"","ref":"XRPL.Transaction.html#xrpl/2"},{"type":"function","title":"XRPL.Transaction.xrpl/3","doc":"","ref":"XRPL.Transaction.html#xrpl/3"},{"type":"module","title":"XRPL.Utility","doc":"Use these methods to perform convenient tasks, such as ping and random number generation.\n\nOfficial documentation: https://xrpl.org/docs/references/http-websocket-apis/public-api-methods/utility-methods/","ref":"XRPL.Utility.html"},{"type":"function","title":"XRPL.Utility.changeset/3","doc":"Builds a changeset from the schema and params.","ref":"XRPL.Utility.html#changeset/3"},{"type":"function","title":"XRPL.Utility.ping/0","doc":"","ref":"XRPL.Utility.html#ping/0"},{"type":"function","title":"XRPL.Utility.ping!/0","doc":"","ref":"XRPL.Utility.html#ping!/0"},{"type":"function","title":"XRPL.Utility.random/0","doc":"","ref":"XRPL.Utility.html#random/0"},{"type":"function","title":"XRPL.Utility.random!/0","doc":"","ref":"XRPL.Utility.html#random!/0"},{"type":"function","title":"XRPL.Utility.schema/1","doc":"","ref":"XRPL.Utility.html#schema/1"},{"type":"function","title":"XRPL.Utility.validate/1","doc":"Returns the validated parameters or an error changeset.","ref":"XRPL.Utility.html#validate/1"},{"type":"function","title":"XRPL.Utility.validate/3","doc":"Returns the validated parameters or an error changeset.\nExpects a schema to be defined with `defparams`.","ref":"XRPL.Utility.html#validate/3"},{"type":"function","title":"XRPL.Utility.xrpl/2","doc":"","ref":"XRPL.Utility.html#xrpl/2"},{"type":"function","title":"XRPL.Utility.xrpl/3","doc":"","ref":"XRPL.Utility.html#xrpl/3"},{"type":"extras","title":"XRPL","doc":"# XRPL\n\nThis library intends to help Elixir developers to integrate and use [XRP Ledger Blockchain](https://xrpl.org/).\n\nIt allows you to interact with its HTTP API and is organized in a manner similar to the [official documentation](https://xrpl.org/http-websocket-apis.html).","ref":"readme.html"},{"type":"extras","title":"Installation - XRPL","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `xrpl` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:xrpl, \"~> 1.0.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - XRPL","doc":"#","ref":"readme.html#usage"},{"type":"extras","title":"Configuration - XRPL","doc":"This library supports configuration through environment variables. You can set the following variables:\n\n```elixir\nconfig :xrpl,\n  network: :mainnet, # Supports :mainnet, :testnet and :devnet\n  mainnet: \"https://s2.ripple.com:51234/\",\n  testnet: \"https://s.altnet.rippletest.net:51234/\",\n  devnet: \"https://s.devnet.rippletest.net:51234/\"\n```\n\nInternally we default to `:mainnet` if no configuration is provided. You can also change the address of each network to fit your needs.\n\nFor example, you may want to use your own devnet node:\n\n```elixir\nconfig :xrpl,\n  network: :devnet,\n  devnet: \"http://localhost:51234/\"\n```\n\n#","ref":"readme.html#configuration"},{"type":"extras","title":"Params - XRPL","doc":"We always use [`Map`](https://hexdocs.pm/elixir/1.16.1/Map.html)s to pass parameters to the functions. This is a design decision to make the code more readable and to avoid the need to remember the order of the parameters.\n\nWe always follow the exact same object from the official documentation. For example, if you want to use the `account_info` command, you can pass the following parameters:\n\n```elixir\nparams = %{\n  # Required\n  account: \"rG1QQv2nh2gr7RCZ1P8YYcBUKCCN633jCn\",\n  # Optional but validated against its format\n  ledger_hash: \"F28F29CB91E3DD5DE2BAE9B794E48AEBD009F1AA8532BFCA391ADEBF96A498DD\",\n  # Optional, String wrapped around an integer. Validated so it's a valid ledger index\n  ledger_index: \"86500345\",\n  queue: true,\n  signer_lists: true\n}\n```\n\nWe also default some params to their official values, mainly with `bool`. \n\n\n#","ref":"readme.html#params"},{"type":"extras","title":"Commands - XRPL","doc":"Our modules mirror the official docs and are simple and easy to understand:\n\n```elixir\niex> XRPL.Account.account_info(%{account: \"rG1QQv2nh2gr7RCZ1P8YYcBUKCCN633jCn\"})\n{:ok,\n %{\n   \"account_data\" => %{\n     \"Account\" => \"rG1QQv2nh2gr7RCZ1P8YYcBUKCCN633jCn\",\n     \"Balance\" => \"10109993\",\n     \"Flags\" => 1048576,\n     \"LedgerEntryType\" => \"AccountRoot\",\n     \"MessageKey\" => \"0200000000000000000000000038901D3A772963CF12FF7C0E010FE350B6CCC45D\",\n     \"OwnerCount\" => 0,\n     \"PreviousTxnID\" => \"23F8BD473F7EF336BC0A50E8270ECD3860BC403E4FB140545690B753EA3041EB\",\n     \"PreviousTxnLgrSeq\" => 84252398,\n     \"RegularKey\" => \"rhLkGGNZdjSpnHJw4XAFw1Jy7PD8TqxoET\",\n     \"Sequence\" => 192222,\n     \"index\" => \"92FA6A9FC8EA6018D5D16532D7795C91BFB0831355BDFDA177E86C8BF997985F\"\n   },\n   \"account_flags\" => %{\n     \"allowTrustLineClawback\" => false,\n     \"defaultRipple\" => false,\n     \"depositAuth\" => false,\n     \"disableMasterKey\" => true,\n     \"disallowIncomingCheck\" => false,\n     \"disallowIncomingNFTokenOffer\" => false,\n     \"disallowIncomingPayChan\" => false,\n     \"disallowIncomingTrustline\" => false,\n     \"disallowIncomingXRP\" => false,\n     \"globalFreeze\" => false,\n     \"noFreeze\" => false,\n     \"passwordSpent\" => false,\n     \"requireAuthorization\" => false,\n     \"requireDestinationTag\" => false\n   },\n   \"ledger_hash\" => \"F28F29CB91E3DD5DE2BAE9B794E48AEBD009F1AA8532BFCA391ADEBF96A498DD\",\n   \"ledger_index\" => 86500345,\n   \"status\" => \"success\",\n   \"validated\" => true\n }}\n```\n\nIf you need insight into the params, we provide a quick way for you to refer back to the official documentation:\n\n```elixir\niex> h XRPL.Account.account_info/1\n\n                            def account_info(params)                            \n\nThe account_info command retrieves information about an account, its activity,\nand its XRP balance. All information retrieved is relative to a particular\nversion of the ledger.\n\nOfficial documentation: https://xrpl.org/account_info.html\n```\n\nOf course this also works on HexDocs: https://hexdocs.pm/xrpl/XRPL.Account.html#account_info/1\n\n\n#","ref":"readme.html#commands"},{"type":"extras","title":"Errors - XRPL","doc":"This library will have predictable errors. If you pass something wrong, you will get an error message that is easy to understand and fix. We may give you the following errors:\n\n- `XRPL.Error{reason: :validation_error}` if you pass invalid parameters\n- `XRPL.Error{reason: :request_error}` if the request to XRPL servers fails\n\nWe also support exceptions so if you want to throw an exception instead of getting the `{:error, reason}` tuple, you can use the bang version of the functions:\n\n```elixir\nXRPL.Account.account_info!(%{account: \"not_a_valid_account\"})\n```\n\nWe also validate the parameters you pass to the functions. Some of the parameters are required and some are optional and you will get predictable [`Ecto.Changeset`](https://hexdocs.pm/ecto/Ecto.html#module-changesets) validation errors if you pass something wrong.\n\n\n#","ref":"readme.html#errors"},{"type":"extras","title":"Utilities - XRPL","doc":"We also provide you with a few useful regex's to validate some of the data you may encounter during development. For example, if you want an regex for a valid XRP address, you can use:\n\n```elixir\niex(1)> XRPL.account_address_regex\n~r/^(?!.*(0|O|I|l))[rR][a-zA-Z1-9]{24,34}$/\n```\nOf course they are available on HexDocs: https://hexdocs.pm/xrpl/XRPL.html#account_address_regex/0\n\nThose regex's are also used internally to validate the parameters you pass to the functions.","ref":"readme.html#utilities"},{"type":"extras","title":"Thanks - XRPL","doc":"This project was part of XRPL Grant Program Wave 5 and was funded by Ripple. Thanks to them for supporting open source projects. Checkout the [announcement here](https://dev.to/ripplexdev/xrpl-grants-wave-5-awardees-driving-innovation-in-the-xrpl-ecosystem-3d9c)","ref":"readme.html#thanks"}],"content_type":"text/markdown"}